Hooks:PostHook(MenuSceneManager, "_set_up_templates", "FlatMenuTemplate", function(self)
	local ref = self._bg_unit:get_object(Idstring("a_camera_reference"))
	local c_ref = self._bg_unit:get_object(Idstring("a_reference"))
	local target_pos = Vector3(0, 0, ref:position().z)
	local offset = Vector3(ref:position().x, ref:position().y, 0)

	self._scene_templates.standard.lights = { -- modified lighting
		self:_create_light({
			far_range = 400,
			color = Vector3(8.5, 6.11, 5.48),
			position = Vector3(80, 33, 20)
		}),
		self:_create_light({
			far_range = 180,
			specular_multiplier = 8,
			color = Vector3(4.57, 5.32, 6),
			position = Vector3(-120, -6, 32)
		}),
		self:_create_light({
			far_range = 800,
			specular_multiplier = 0,
			color = Vector3(0.7, 0.7, 0.7),
			position = Vector3(160, -250, -40)
		})
	}

	self._scene_templates.standard.show_mm10_event = false

	self._scene_templates.infamy_preview = { -- modified lighting
		fov = 40,
		can_change_fov = false,
		use_item_grab = true,
		camera_pos = offset:rotate_with(Rotation(90)) + Vector3(0, 0, 202),
		target_pos = target_pos + Vector3(0, 0, 200),
		character_pos = Vector3(-75, 10, 100),
		hide_armor = true,
		hide_mask = true,
		hide_weapons = true,
		disable_rotate = true,
		character_visible = true,
		use_character_grab2 = false,
		use_character_pan = false,
		lights = {
			self:_create_light({
				far_range = 250,
				specular_multiplier = 55,
				color = Vector3(0.67, 0.82, 1) * 4.3,
				position = Vector3(0, -200, 280)
			}),
			self:_create_light({
				far_range = 370,
				specular_multiplier = 55,
				color = Vector3(1, 0.92, 0.82) * 2.3,
				position = Vector3(200, 60, 280)
			}),
			self:_create_light({
				far_range = 270,
				specular_multiplier = 0,
				color = Vector3(1, 1, 1) * 0.8,
				position = Vector3(160, -130, 220)
			}),
			self:_create_light({
				far_range = 270,
				specular_multiplier = 155,
				color = Vector3(0.86, 0.82, 0.69) * 2,
				position = Vector3(160, 0, 220)
			})
		}
	}

	self._scene_templates.character_customization = {
		use_character_grab = true,
		camera_pos = Vector3(-73.1618, -168.021, -35.0786),
		target_pos = Vector3(-73.1618, -168.021, -35.0786) + Vector3(0.31113, 0.944697, -0.103666) * 100,
		lights = clone(self._scene_templates.standard.lights)
	}

	self._scene_templates.lobby = { -- modified lighting
		use_character_grab = false,
		camera_pos = offset:rotate_with(Rotation(90)),
		target_pos = target_pos,
		character_pos = c_ref:position() + Vector3(0, 500, 0),
		lobby_characters_visible = true,
		fov = 40,
		lights = {
			self:_create_light({
				far_range = 300,
				color = Vector3(0.86, 0.77, 0.64) * 3,
				position = Vector3(56, 100, -10)
			}),
			self:_create_light({
				far_range = 3000,
				specular_multiplier = 6,
				color = Vector3(1, 1.82, 2.82) * 3,
				position = Vector3(-1000, -300, 800)
			}),
			self:_create_light({
				far_range = 800,
				specular_multiplier = 0,
				color = Vector3(1, 1, 1) * 0.35,
				position = Vector3(300, 100, 0)
			})
		}
	}

	self._scene_templates.lobby1 = {
		use_character_grab = false,
		lobby_characters_visible = true,
		camera_pos = Vector3(-90.5634, -157.226, -28.6729),
		target_pos = Vector3(-90.5634, -157.226, -28.6729) + Vector3(-0.58315, 0.781811, 0.220697) * 100,
		fov = 30,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.lobby2 = {
		use_character_grab = false,
		lobby_characters_visible = true,
		camera_pos = Vector3(-21.2779, -264.36, -56.7304),
		target_pos = Vector3(-21.2779, -264.36, -56.7304) + Vector3(-0.633319, 0.758269, 0.154709) * 100,
		fov = 30,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.lobby3 = {
		use_character_grab = false,
		lobby_characters_visible = true,
		camera_pos = Vector3(149.695, -363.069, -110.613),
		target_pos = Vector3(149.695, -363.069, -110.613) + Vector3(-0.648856, 0.748553, 0.136579) * 100,
		fov = 30,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.lobby4 = {
		use_character_grab = false,
		lobby_characters_visible = true,
		camera_pos = Vector3(210.949, -449.61, -126.709),
		target_pos = Vector3(210.949, -449.61, -126.709) + Vector3(-0.668524, 0.734205, 0.118403) * 100,
		fov = 30,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.blackmarket_item.lights = {
		self:_create_light({
			far_range = 270,
			specular_multiplier = 155,
			color = Vector3(0.86, 0.67, 0.31) * 3,
			position = Vector3(160, -130, 220)
		}),
		self:_create_light({
			far_range = 270,
			specular_multiplier = 155,
			color = Vector3(0.86, 0.67, 0.41) * 2,
			position = Vector3(50, -150, 220)
		}),
		self:_create_light({
			far_range = 270,
			specular_multiplier = 155,
			color = Vector3(0.86, 0.67, 0.41) * 2,
			position = Vector3(160, 0, 220)
		}),
		self:_create_light({
			far_range = 250,
			specular_multiplier = 55,
			color = Vector3(0.5, 1.5, 2) * 2,
			position = Vector3(50, -100, 280)
		}),
		self:_create_light({
			far_range = 370,
			specular_multiplier = 55,
			color = Vector3(1, 0.4, 0.04) * 1.5,
			position = Vector3(200, 60, 180)
		})
	}

	self._scene_templates.inventory = {
		fov = 50,
		can_change_fov = true,
		change_fov_sensitivity = 3,
		use_character_grab2 = true,
		use_character_pan = true,
		character_visible = true,
		recreate_character = true,
		lobby_characters_visible = false,
		hide_menu_logo = true,
		camera_pos = ref:position(),
		target_pos = target_pos - self._camera_start_rot:x() * 40 - self._camera_start_rot:z() * 5 + self._camera_start_rot:y() * 20,
		character_pos = c_ref:position(),
		remove_infamy_card = true
	}

	self._scene_templates.inventory.lights = { -- modified lighting
		self:_create_light({
			far_range = 400,
			color = Vector3(0.86, 0.67, 0.59) * 4,
			position = Vector3(80, 33, 20)
		}),
		self:_create_light({
			far_range = 180,
			specular_multiplier = 8,
			color = Vector3(0.61, 0.71, 0.8) * 6,
			position = Vector3(-120, -6, 32)
		}),
		self:_create_light({
			far_range = 800,
			specular_multiplier = 0,
			color = Vector3(1, 1, 1) * 0.35,
			position = Vector3(160, -250, -40)
		})
	}

	self._scene_templates.crime_spree_lobby = { -- copy & paste lobby
		use_character_grab = false,
		camera_pos = offset:rotate_with(Rotation(90)),
		target_pos = target_pos,
		character_pos = c_ref:position() + Vector3(0, 500, 0),
		lobby_characters_visible = true,
		fov = 40,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.crew_management = { -- copy & paste lobby
		use_character_grab = false,
		camera_pos = offset:rotate_with(Rotation(90)),
		target_pos = target_pos,
		character_pos = c_ref:position() + Vector3(0, 500, 0),
		character_visible = false,
		lobby_characters_visible = false,
		henchmen_characters_visible = true,
		fov = 40,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.raid_menu = { -- copy & paste lobby
		use_character_grab = false,
		camera_pos = offset:rotate_with(Rotation(90)),
		target_pos = target_pos,
		character_pos = c_ref:position() + Vector3(0, 500, 0),
		character_visible = false,
		lobby_characters_visible = false,
		henchmen_characters_visible = true,
		fov = 40,
		lights = clone(self._scene_templates.lobby.lights)
	}

	self._scene_templates.movie_theater = {
		use_character_grab = false,
		camera_pos = offset:rotate_with(Rotation(90)),
		target_pos = target_pos,
		character_visible = false,
		lobby_characters_visible = false,
		fov = 40
	}
end)

function MenuSceneManager:_setup_bg()
	local yaw = 180
	self._bg_unit = World:spawn_unit(Idstring("units/menu/menu_scene/menu_cylinder"), Vector3(0, 0, 0), Rotation(yaw, 0, 0))

	World:spawn_unit(Idstring("units/menu/menu_scene/menu_cylinder_pattern"), Vector3(0, 0, 0), Rotation(yaw, 0, 0))
	World:spawn_unit(Idstring("units/menu/menu_scene/menu_smokecylinder1"), Vector3(0, 0, 0), Rotation(yaw, 0, 0))
	World:spawn_unit(Idstring("units/menu/menu_scene/menu_smokecylinder2"), Vector3(0, 0, 0), Rotation(yaw, 0, 0))
	World:spawn_unit(Idstring("units/menu/menu_scene/menu_smokecylinder3"), Vector3(0, 0, 0), Rotation(yaw, 0, 0))

	self._menu_logo = World:spawn_unit(Idstring("units/menu/menu_scene/menu_logo"), Vector3(0, 10, 0), Rotation(yaw, 0, 0))

	self:set_character(managers.blackmarket:get_preferred_character())
	self:_setup_lobby_characters()
	self:_setup_henchmen_characters()
end

function MenuSceneManager:_set_up_environments()
	self._environments = {
		standard = {}
	}
	self._environments.standard.environment = "environments/env_menu/env_menu"
	self._environments.standard.color_grading = "color_heat"
	self._environments.standard.angle = 0
	self._environments.safe = {
		environment = "environments/pd2_cash/env_cash_01",
		color_grading = "color_off",
		angle = -135
	}
	self._environments.crafting = {
		environment = "environments/pd2_cash/env_cash_02",
		color_grading = "color_off",
		angle = -135
	}
end
